/[gentoo-x86]/eclass/mysql.eclass
Gentoo

Diff of /eclass/mysql.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.78 Revision 1.88
1# Copyright 1999-2007 Gentoo Foundation 1# Copyright 1999-2007 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.78 2007/05/11 08:25:11 robbat2 Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.88 2008/03/10 02:47:20 robbat2 Exp $
4 4
5# Author: Francesco Riosa (Retired) <vivo@gentoo.org> 5# Author: Francesco Riosa (Retired) <vivo@gentoo.org>
6# Maintainer: MySQL Team <mysql-bugs@gentoo.org>
6# Maintainer: Luca Longinotti <chtekk@gentoo.org> 7# - Luca Longinotti <chtekk@gentoo.org>
7 8# - Robin H. Johnson <robbat2@gentoo.org>
8# Both MYSQL_VERSION_ID and MYSQL_PATCHSET_REV must be set in the ebuild too!
9# Note that MYSQL_VERSION_ID must be empty!
10 9
11WANT_AUTOCONF="latest" 10WANT_AUTOCONF="latest"
12WANT_AUTOMAKE="latest" 11WANT_AUTOMAKE="latest"
13 12
14inherit eutils flag-o-matic gnuconfig autotools mysql_fx 13inherit eutils flag-o-matic gnuconfig autotools mysql_fx
16# Shorten the path because the socket path length must be shorter than 107 chars 15# Shorten the path because the socket path length must be shorter than 107 chars
17# and we will run a mysql server during test phase 16# and we will run a mysql server during test phase
18S="${WORKDIR}/mysql" 17S="${WORKDIR}/mysql"
19 18
20[[ "${MY_EXTRAS_VER}" == "latest" ]] && MY_EXTRAS_VER="20070108" 19[[ "${MY_EXTRAS_VER}" == "latest" ]] && MY_EXTRAS_VER="20070108"
20if [[ "${MY_EXTRAS_VER}" == "live" ]]; then
21 EGIT_PROJECT=mysql-extras
22 EGIT_REPO_URI="git://git.overlays.gentoo.org/proj/mysql-extras.git"
23 inherit git
24fi
21 25
22if [[ ${PR#r} -lt 60 ]] ; then 26if [[ ${PR#r} -lt 60 ]] ; then
23 IS_BITKEEPER=0 27 IS_BITKEEPER=0
24elif [[ ${PR#r} -lt 90 ]] ; then 28elif [[ ${PR#r} -lt 90 ]] ; then
25 IS_BITKEEPER=60 29 IS_BITKEEPER=60
30# MYSQL_VERSION_ID will be: 34# MYSQL_VERSION_ID will be:
31# major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99] 35# major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99]
32# This is an important part, because many of the choices the MySQL ebuild will do 36# This is an important part, because many of the choices the MySQL ebuild will do
33# depend on this variable. 37# depend on this variable.
34# In particular, the code below transforms a $PVR like "5.0.18-r3" in "5001803" 38# In particular, the code below transforms a $PVR like "5.0.18-r3" in "5001803"
39# We also strip off upstream's trailing letter that they use to respin tarballs
35 40
36MYSQL_VERSION_ID="" 41MYSQL_VERSION_ID=""
42tpv="${PV%[a-z]}"
37tpv=( ${PV//[-._]/ } ) ; tpv[3]="${PVR:${#PV}}" ; tpv[3]="${tpv[3]##*-r}" 43tpv=( ${tpv//[-._]/ } ) ; tpv[3]="${PVR:${#PV}}" ; tpv[3]="${tpv[3]##*-r}"
38for vatom in 0 1 2 3 ; do 44for vatom in 0 1 2 3 ; do
39 # pad to length 2 45 # pad to length 2
40 tpv[${vatom}]="00${tpv[${vatom}]}" 46 tpv[${vatom}]="00${tpv[${vatom}]}"
41 MYSQL_VERSION_ID="${MYSQL_VERSION_ID}${tpv[${vatom}]:0-2}" 47 MYSQL_VERSION_ID="${MYSQL_VERSION_ID}${tpv[${vatom}]:0-2}"
42done 48done
67PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )" 73PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )"
68 74
69# BitKeeper dependency, compile-time only 75# BitKeeper dependency, compile-time only
70[[ ${IS_BITKEEPER} -eq 90 ]] && DEPEND="${DEPEND} dev-util/bk_client" 76[[ ${IS_BITKEEPER} -eq 90 ]] && DEPEND="${DEPEND} dev-util/bk_client"
71 77
78# Work out the default SERVER_URI correctly
79if [ -z "${SERVER_URI}" ]; then
80 # The community build is on the mirrors
81 if [ "${PN}" == "mysql-community" ]; then
82 SERVER_URI="mirror://mysql/Downloads/MySQL-${PV%.*}/mysql-${PV//_/-}.tar.gz"
83 # The enterprise source is on the primary site only
84 elif [ "${PN}" == "mysql" ]; then
85 SERVER_URI="ftp://ftp.mysql.com/pub/mysql/src/mysql-${PV//_/-}.tar.gz"
86 fi
87fi
88
72# Define correct SRC_URIs 89# Define correct SRC_URIs
73SRC_URI="${SERVER_URI} 90SRC_URI="${SERVER_URI}"
91
92[[ ${MY_EXTRAS_VER} != live ]] && SRC_URI="${SRC_URI}
74 mirror://gentoo/mysql-extras-${MY_EXTRAS_VER}.tar.bz2 93 mirror://gentoo/mysql-extras-${MY_EXTRAS_VER}.tar.bz2
75 http://g3nt8.org/patches/mysql-extras-${MY_EXTRAS_VER}.tar.bz2" 94 http://g3nt8.org/patches/mysql-extras-${MY_EXTRAS_VER}.tar.bz2"
76mysql_version_is_at_least "5.1.12" \ 95mysql_version_is_at_least "5.1.12" \
77&& [[ -n "${PBXT_VERSION}" ]] \ 96&& [[ -n "${PBXT_VERSION}" ]] \
78&& SRC_URI="${SRC_URI} pbxt? ( mirror://sourceforge/pbxt/pbxt-${PBXT_VERSION}.tar.gz )" 97&& SRC_URI="${SRC_URI} pbxt? ( mirror://sourceforge/pbxt/pbxt-${PBXT_VERSION}.tar.gz )"
80DESCRIPTION="A fast, multi-threaded, multi-user SQL database server." 99DESCRIPTION="A fast, multi-threaded, multi-user SQL database server."
81HOMEPAGE="http://www.mysql.com/" 100HOMEPAGE="http://www.mysql.com/"
82LICENSE="GPL-2" 101LICENSE="GPL-2"
83SLOT="0" 102SLOT="0"
84IUSE="big-tables debug embedded minimal perl selinux ssl static" 103IUSE="big-tables debug embedded minimal perl selinux ssl static"
85RESTRICT="confcache"
86 104
87mysql_version_is_at_least "4.1" \ 105mysql_version_is_at_least "4.1" \
88&& IUSE="${IUSE} latin1" 106&& IUSE="${IUSE} latin1"
89 107
90mysql_version_is_at_least "4.1.3" \ 108mysql_version_is_at_least "4.1.3" \
239 257
240configure_minimal() { 258configure_minimal() {
241 # These are things we exclude from a minimal build, please 259 # These are things we exclude from a minimal build, please
242 # note that the server actually does get built and installed, 260 # note that the server actually does get built and installed,
243 # but we then delete it before packaging. 261 # but we then delete it before packaging.
244 local minimal_exclude_list="server embedded-server extra-tools innodb bench berkeley-db row-based-replication" 262 local minimal_exclude_list="server embedded-server extra-tools innodb bench berkeley-db row-based-replication readline"
245 263
246 for i in ${minimal_exclude_list} ; do 264 for i in ${minimal_exclude_list} ; do
247 myconf="${myconf} --without-${i}" 265 myconf="${myconf} --without-${i}"
248 done 266 done
249 myconf="${myconf} --with-extra-charsets=none" 267 myconf="${myconf} --with-extra-charsets=none"
250 myconf="${myconf} --enable-local-infile" 268 myconf="${myconf} --enable-local-infile"
251 269
252 if use static ; then 270 if use static ; then
253 myconf="${myconf} --with-client-ldflags=-all-static" 271 myconf="${myconf} --with-client-ldflags=-all-static"
254 myconf="${myconf} --disable-shared" 272 myconf="${myconf} --disable-shared --with-pic"
255 else 273 else
256 myconf="${myconf} --enable-shared --enable-static" 274 myconf="${myconf} --enable-shared --enable-static"
257 fi 275 fi
258 276
259 if mysql_version_is_at_least "4.1" && ! use latin1 ; then 277 if mysql_version_is_at_least "4.1" && ! use latin1 ; then
275 myconf="${myconf} --without-libwrap" 293 myconf="${myconf} --without-libwrap"
276 294
277 if use static ; then 295 if use static ; then
278 myconf="${myconf} --with-mysqld-ldflags=-all-static" 296 myconf="${myconf} --with-mysqld-ldflags=-all-static"
279 myconf="${myconf} --with-client-ldflags=-all-static" 297 myconf="${myconf} --with-client-ldflags=-all-static"
280 myconf="${myconf} --disable-shared" 298 myconf="${myconf} --disable-shared --with-pic"
281 else 299 else
282 myconf="${myconf} --enable-shared --enable-static" 300 myconf="${myconf} --enable-shared --enable-static"
283 fi 301 fi
284 302
285 if use debug ; then 303 if use debug ; then
441} 459}
442 460
443# 461#
444# EBUILD FUNCTIONS 462# EBUILD FUNCTIONS
445# 463#
446
447mysql_pkg_setup() { 464mysql_pkg_setup() {
448 enewgroup mysql 60 || die "problem adding 'mysql' group" 465 if hasq test ${FEATURES} ; then
449 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user" 466 if ! use minimal ; then
467 if ! hasq userpriv ${FEATURES} ; then
468 die "Testing with FEATURES=-userpriv is no longer supported by upstream"
469 fi
470 fi
471 fi
450 472
451 # Check for USE flag problems in pkg_setup 473 # Check for USE flag problems in pkg_setup
452 if use static && use ssl ; then 474 if use static && use ssl ; then
453 eerror "MySQL does not support being built statically with SSL support enabled!" 475 eerror "MySQL does not support being built statically with SSL support enabled!"
454 die "MySQL does not support being built statically with SSL support enabled!" 476 die "MySQL does not support being built statically with SSL support enabled!"
466 && ( use cluster || use extraengine ) \ 488 && ( use cluster || use extraengine ) \
467 && use minimal ; then 489 && use minimal ; then
468 eerror "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!" 490 eerror "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
469 die "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!" 491 die "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
470 fi 492 fi
493
494 # This should come after all of the die statements
495 enewgroup mysql 60 || die "problem adding 'mysql' group"
496 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user"
471 497
472 mysql_check_version_range "4.0 to 5.0.99.99" \ 498 mysql_check_version_range "4.0 to 5.0.99.99" \
473 && use berkdb \ 499 && use berkdb \
474 && elog "Berkeley DB support is deprecated and will be removed in future versions!" 500 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
475} 501}
477mysql_src_unpack() { 503mysql_src_unpack() {
478 # Initialize the proper variables first 504 # Initialize the proper variables first
479 mysql_init_vars 505 mysql_init_vars
480 506
481 unpack ${A} 507 unpack ${A}
508 # Grab the patches
509 [[ "${MY_EXTRAS_VER}" == "live" ]] && S="${WORKDIR}/mysql-extras" git_src_unpack
510 # Bitkeeper checkout support
482 if [[ ${IS_BITKEEPER} -eq 90 ]] ; then 511 if [[ ${IS_BITKEEPER} -eq 90 ]] ; then
483 if mysql_check_version_range "5.1 to 5.1.99" ; then 512 if mysql_check_version_range "5.1 to 5.1.99" ; then
484 bitkeeper_fetch "mysql-5.1-ndb" 513 bitkeeper_fetch "mysql-5.1-ndb"
485 elif mysql_check_version_range "5.2 to 5.2.99" ; then 514 elif mysql_check_version_range "5.2 to 5.2.99" ; then
486 bitkeeper_fetch "mysql-5.2-falcon" 515 bitkeeper_fetch "mysql-5.2-falcon"
496 fi 525 fi
497 526
498 # Apply the patches for this MySQL version 527 # Apply the patches for this MySQL version
499 EPATCH_SUFFIX="patch" 528 EPATCH_SUFFIX="patch"
500 mkdir -p "${EPATCH_SOURCE}" || die "Unable to create epatch directory" 529 mkdir -p "${EPATCH_SOURCE}" || die "Unable to create epatch directory"
530 # Clean out old items
531 rm -f "${EPATCH_SOURCE}"/*
532 # Now link in right patches
501 mysql_mv_patches 533 mysql_mv_patches
534 # And apply
502 epatch 535 epatch
503 536
504 # Additional checks, remove bundled zlib 537 # Additional checks, remove bundled zlib
505 rm -f "${S}/zlib/"*.[ch] 538 rm -f "${S}/zlib/"*.[ch]
506 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in" 539 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in"
526 rebuilddirlist="." 559 rebuilddirlist="."
527 # TODO: check this with a cmake expert 560 # TODO: check this with a cmake expert
528 use innodb \ 561 use innodb \
529 && cmake \ 562 && cmake \
530 -DCMAKE_C_COMPILER=$(type -P $(tc-getCC)) \ 563 -DCMAKE_C_COMPILER=$(type -P $(tc-getCC)) \
531 -DCMAKE_CXX_COMPILER=$(type -P $(tc-getCC)) \ 564 -DCMAKE_CXX_COMPILER=$(type -P $(tc-getCXX)) \
532 "storage/innobase" 565 "storage/innobase"
533 else 566 else
534 rebuilddirlist=". innobase" 567 rebuilddirlist=". innobase"
535 fi 568 fi
536 569
801 && cp "${help_tables}" "${TMPDIR}/fill_help_tables.sql" \ 834 && cp "${help_tables}" "${TMPDIR}/fill_help_tables.sql" \
802 || touch "${TMPDIR}/fill_help_tables.sql" 835 || touch "${TMPDIR}/fill_help_tables.sql"
803 help_tables="${TMPDIR}/fill_help_tables.sql" 836 help_tables="${TMPDIR}/fill_help_tables.sql"
804 837
805 pushd "${TMPDIR}" &>/dev/null 838 pushd "${TMPDIR}" &>/dev/null
806 "${ROOT}/usr/bin/mysql_install_db" | grep -B5 -A999 -i "ERROR" 839 "${ROOT}/usr/bin/mysql_install_db" >"${TMPDIR}"/mysql_install_db.log 2>&1
840 if [ $? -ne 0 ]; then
841 grep -B5 -A999 -i "ERROR" "${TMPDIR}"/mysql_install_db.log 1>&2
842 die "Failed to run mysql_install_db. Please review /var/log/mysql/mysqld.err AND ${TMPDIR}/mysql_install_db.log"
843 fi
807 popd &>/dev/null 844 popd &>/dev/null
808 [[ -f "${ROOT}/${MY_DATADIR}/mysql/user.frm" ]] \ 845 [[ -f "${ROOT}/${MY_DATADIR}/mysql/user.frm" ]] \
809 || die "MySQL databases not installed" 846 || die "MySQL databases not installed"
810 chown -R mysql:mysql "${ROOT}/${MY_DATADIR}" 2> /dev/null 847 chown -R mysql:mysql "${ROOT}/${MY_DATADIR}" 2> /dev/null
811 chmod 0750 "${ROOT}/${MY_DATADIR}" 2> /dev/null 848 chmod 0750 "${ROOT}/${MY_DATADIR}" 2> /dev/null

Legend:
Removed from v.1.78  
changed lines
  Added in v.1.88

  ViewVC Help
Powered by ViewVC 1.1.20